//TicTacToe 2404 see 3vr.c.
class CTicTacToe
{
public:
	enum TYPE_PANE_VALUE { E_EMPTY = 0, E_OCCUPIED = 1 };
	enum TYPE_PLAYER { E_PLAYER0 = 0, E_PLAYER1, E_PLAYER_NUM };
	enum TYPE_PATTERN { E_H0, E_H1, E_H2, E_V0, E_V1, E_V2, E_TOPLEFT, E_TOPRIGHT, E_PATTERNNUM = 8 };
private:
	static const int COL_NUM = 3;
	union CBoard
	{
		unsigned short miStatus;
		bitset<COL_NUM * COL_NUM> maBitsStatus;
		CBoard() { miStatus = 0; }
	};
	CBoard maBoards[E_PLAYER_NUM];
	static const unsigned short maWinningPatterns[E_PATTERNNUM];
public:
	bool Drop(TYPE_PLAYER ePlayer, int iLocX, int iLocY, bool& bWin);
	bool Win(TYPE_PLAYER ePlayer);
	CTicTacToe() {};
};
const unsigned short CTicTacToe::maWinningPatterns[E_PATTERNNUM] =
{
	0b111000000, 0b000111000, 0b000000111, //rows
	0b100100100, 0b010010010, 0b001001001, //cols
	0b100010001, 0b001010100,
};
bool CTicTacToe::Drop(TYPE_PLAYER ePlayer, int iLocX, int iLocY, bool& bWin)
{
	size_t iIndex = iLocY * COL_NUM + iLocX;
	TYPE_PLAYER other = static_cast<TYPE_PLAYER>((ePlayer + 1) % E_PLAYER_NUM);
	if (maBoards[other].maBitsStatus[iIndex])
		return false;
	maBoards[ePlayer].maBitsStatus[iIndex] = E_OCCUPIED;
	bWin = Win(ePlayer);
	return true;
}
bool CTicTacToe::Win(TYPE_PLAYER ePlayer)
{
	bool bResult = false;
	for (size_t i = 0; i < E_PATTERNNUM; i++)
		if ((maWinningPatterns[i] & maBoards[ePlayer].miStatus) == maWinningPatterns[i])
		{
			bResult = true;
			break;
		}
	return bResult;
}
void TestTicTacToe()
{
	CTicTacToe Tic;
	bool bWin, bReturn;
	Tic.Drop(CTicTacToe::E_PLAYER0, 0, 0, bWin);
	bReturn = Tic.Drop(CTicTacToe::E_PLAYER1, 0, 0, bWin);
	assert(!bReturn); //already occupied
	Tic.Drop(CTicTacToe::E_PLAYER0, 0, 1, bWin);
	assert(!bWin);
	Tic.Drop(CTicTacToe::E_PLAYER0, 0, 2, bWin);
	assert(bWin);
}
